"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ButtonComponent = (function () {
    function ButtonComponent() {
        this.onClick = new core_1.EventEmitter();
        this.elementId = 'button-' + new Date().getTime() + Math.random();
    }
    ButtonComponent.prototype.ngOnInit = function () {
        this.btnStyleClass = 'btn ';
        this.btnSizeStyleClass = '';
        if (this.type.toLocaleLowerCase() == 'warning')
            this.btnStyleClass = this.btnStyleClass + 'btn-warning';
        else if (this.type.toLocaleLowerCase() == 'primary')
            this.btnStyleClass = this.btnStyleClass + 'btn-primary';
        else if (this.type.toLocaleLowerCase() == 'success')
            this.btnStyleClass = this.btnStyleClass + 'btn-success';
        else if (this.type.toLocaleLowerCase() == 'danger')
            this.btnStyleClass = this.btnStyleClass + 'btn-danger';
        else
            this.btnStyleClass = this.btnStyleClass + 'btn-default';
        this.iconStyleClass = 'glyphicon glyphicon-' + this.icon + ' pull-right';
        if (this.tooltipMessage == null)
            this.hasToolTip = false;
        if (this.size != null) {
            if (this.size == 'large')
                this.btnStyleClass = this.btnStyleClass.concat(' btn-lg');
            else if (this.size == 'small')
                this.btnStyleClass = this.btnStyleClass.concat(' btn-sm');
            else if (this.size == 'xsmall')
                this.btnStyleClass = this.btnStyleClass.concat(' btn-xs');
        }
        if (this.block) {
            this.btnStyleClass = this.btnStyleClass.concat(' btn-block');
        }
    };
    ButtonComponent.prototype.ngOnChanges = function (change) {
        /*console.log(change.isLoading);
          if(change.isLoading){
            this.disabled = true;
          }*/ //TODO : Fix
    };
    ButtonComponent.prototype.ngAfterViewInit = function () {
    };
    ButtonComponent.prototype.btnClick = function (event) {
        this.onClick.emit(event);
        if (this.onClickRoute != null) {
            // this.router.navigate([this.onClickRoute]);
        }
    };
    return ButtonComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonComponent.prototype, "icon", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonComponent.prototype, "type", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonComponent.prototype, "onClickRoute", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonComponent.prototype, "tooltipMessage", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], ButtonComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], ButtonComponent.prototype, "isLoading", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonComponent.prototype, "size", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], ButtonComponent.prototype, "block", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonComponent.prototype, "fieldName", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], ButtonComponent.prototype, "onClick", void 0);
ButtonComponent = __decorate([
    core_1.Component({
        selector: 'button-action',
        template: "\n      <div>\n          <button (click)=\"btnClick($event)\"\n                  [class]=\"btnStyleClass\"\n                  [attr.fieldName] = \"fieldName\"\n                  [attr.disabled] = \"disabled ? true: null\"\n                  data-toggle=\"tooltip\" data-placement=\"bottom\" [attr.title]=\"tooltipMessage\"\n          >\n              <ng-container *ngIf=\"isLoading\">\n                  <span class=\"glyphicon glyphicon-refresh glyphicon-refresh-animate\"></span>&nbsp;&nbsp;&nbsp;\n              </ng-container>\n              {{label}}\n              <ng-container *ngIf=\"icon!=null\">\n                  &nbsp;<span [class]=\"iconStyleClass\"></span>\n              </ng-container>\n          </button>\n      </div>\n\n  ",
        styles: ["\n  .glyphicon-refresh-animate {\n    -animation: spin .7s infinite linear;\n    -webkit-animation: spin2 .7s infinite linear;\n}\n\n@-webkit-keyframes spin2 {\n    from { -webkit-transform: rotate(0deg);}\n    to { -webkit-transform: rotate(360deg);}\n}\n\n@keyframes spin {\n    from { transform: scale(1) rotate(0deg);}\n    to { transform: scale(1) rotate(360deg);}\n}"
        ]
    }),
    __metadata("design:paramtypes", [])
], ButtonComponent);
exports.ButtonComponent = ButtonComponent;
//# sourceMappingURL=button.component.js.map