"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var dropdown_item_component_1 = require("./dropdown.item.component");
var ButtonDropdownComponent = (function () {
    function ButtonDropdownComponent() {
        this.elementId = 'button-dropdown' + new Date().getTime() + Math.random();
    }
    ButtonDropdownComponent.prototype.ngOnInit = function () {
        this.btnStyleClass = 'btn ';
        this.btnDropdownStyle = 'dropdown-toggle';
        if (this.type != '' || this.type != null) {
            if (this.type == 'warning')
                this.btnStyleClass = this.btnStyleClass + 'btn-warning';
            else if (this.type == 'primary')
                this.btnStyleClass = this.btnStyleClass + 'btn-primary';
            else if (this.type == 'success')
                this.btnStyleClass = this.btnStyleClass + 'btn-success';
            else if (this.type == 'danger')
                this.btnStyleClass = this.btnStyleClass + 'btn-danger';
        }
        else
            this.btnStyleClass = this.btnStyleClass + 'btn-default';
        if (this.size != null) {
            this.btnGroupStyleClass = 'btn-group ';
            if (this.size != null) {
                if (this.size == 'large')
                    this.btnGroupStyleClass = this.btnGroupStyleClass.concat(' btn-group-lg');
                else if (this.size == 'small')
                    this.btnGroupStyleClass = this.btnGroupStyleClass.concat(' btn-group-sm');
                else if (this.size == 'xsmall')
                    this.btnGroupStyleClass = this.btnGroupStyleClass.concat(' btn-group-xs');
            }
        }
        this.btnDropdownStyle = this.btnStyleClass + ' ' + this.btnDropdownStyle;
    };
    ButtonDropdownComponent.prototype.ngAfterContentInit = function () {
        this.createConfig();
    };
    ButtonDropdownComponent.prototype.createConfig = function () {
        this.dropdownItemData = [];
        this.createDropdownItemConfig();
    };
    ButtonDropdownComponent.prototype.createDropdownItemConfig = function () {
        var itemRefArray = [];
        itemRefArray = this.dropdownItemRef.toArray();
        for (var cr = 0; cr < itemRefArray.length; cr++) {
            var itemConfig = itemRefArray[cr];
            var data = { label: itemConfig.label, disabled: itemConfig.disabled, onItemClick: itemConfig.onItemClick, iconStyleClass: itemConfig.iconStyleClass, icon: itemConfig.icon, onClickRoute: itemConfig.onClickRoute };
            data.iconStyleClass = 'glyphicon glyphicon-' + data.icon + ' pull-right';
            this.dropdownItemData.push(data);
        }
    };
    ButtonDropdownComponent.prototype.itemClick = function (event, itemData) {
        itemData.onItemClick.emit(event);
        if (itemData.onClickRoute != null) {
            // this.router.navigate([itemData.onClickRoute]);
        }
    };
    return ButtonDropdownComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonDropdownComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonDropdownComponent.prototype, "type", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonDropdownComponent.prototype, "size", void 0);
__decorate([
    core_1.ContentChildren(dropdown_item_component_1.ItemComponent),
    __metadata("design:type", core_1.QueryList)
], ButtonDropdownComponent.prototype, "dropdownItemRef", void 0);
ButtonDropdownComponent = __decorate([
    core_1.Component({
        selector: 'button-dropdown',
        template: "    \n      <div [class]=\"btnGroupStyleClass\" [attr.id]=\"elementId\">\n        <button type=\"button\" [class]=\"btnStyleClass\">{{label}}</button>\n        <button type=\"button\" [class]=\"btnDropdownStyle\" data-toggle=\"dropdown\">\n          <span class=\"caret\"></span>\n        </button>\n        <ul class=\"dropdown-menu\" role=\"menu\">\n          <li class=\"lidisabled\" [ngClass]=\"{'lidisabled':itemData.disabled}\" *ngFor=\"let itemData of dropdownItemData\" (click)=\"itemClick($event,itemData)\">\n            <a style=\"cursor :pointer\">{{itemData.label}}<ng-container *ngIf=\"itemData.icon!=null\">\n            <span [class]=\"itemData.iconStyleClass\"></span>\n             </ng-container>\n            </a>\n          </li>\n        </ul>\n      </div>\n  ",
        styles: ["\n    .lidisabled {\n      pointer-events: none;\n      opacity: 0.6;\n      background-color: lightgray\n    }\n  "]
    }),
    __metadata("design:paramtypes", [])
], ButtonDropdownComponent);
exports.ButtonDropdownComponent = ButtonDropdownComponent;
//# sourceMappingURL=button.dropdown.component.js.map