"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var buttongroup_action_component_1 = require("./buttongroup.action.component");
var ButtonGroupComponent = (function () {
    function ButtonGroupComponent() {
        this.elementId = 'button-group' + new Date().getTime() + Math.random();
    }
    ButtonGroupComponent.prototype.ngAfterContentInit = function () {
        this.createConfig();
    };
    ButtonGroupComponent.prototype.ngOnInit = function () {
        this.btnGroupStyleClass = 'btn-group ';
        if (this.size != null) {
            if (this.size == 'large')
                this.btnGroupStyleClass = this.btnGroupStyleClass.concat(' btn-group-lg');
            else if (this.size == 'small')
                this.btnGroupStyleClass = this.btnGroupStyleClass.concat(' btn-group-sm');
            else if (this.size == 'xsmall')
                this.btnGroupStyleClass = this.btnGroupStyleClass.concat(' btn-group-xs');
        }
    };
    ButtonGroupComponent.prototype.createConfig = function () {
        this.buttonData = [];
        this.createButtonConfig();
    };
    ButtonGroupComponent.prototype.buttonClick = function (event, btnObj) {
        btnObj.onClick.emit(event);
        if (btnObj.onClickRoute != null) {
            // this.router.navigate([this.onClickRoute]);
        }
    };
    ButtonGroupComponent.prototype.createButtonConfig = function () {
        var buttonRefArray = [];
        buttonRefArray = this.buttonComponentRef.toArray();
        for (var cr = 0; cr < buttonRefArray.length; cr++) {
            var buttonConfig = buttonRefArray[cr];
            var data = { label: buttonConfig.label, onClick: buttonConfig.onClick, icon: buttonConfig.icon, type: buttonConfig.type, tooltipMessage: buttonConfig.tooltipMessage, onClickRoute: buttonConfig.onClickRoute, disabled: buttonConfig.disabled,
                isLoading: buttonConfig.isLoading, fieldName: buttonConfig.fieldName, btnStyleClass: buttonConfig.btnStyleClass, iconStyleClass: buttonConfig.iconStyleClass,
                btnSizeStyleClass: buttonConfig.btnSizeStyleClass, hasToolTip: buttonConfig.hasToolTip, elementId: buttonConfig.elementId };
            this.buttonData.push(data);
        }
        console.log(this.buttonData);
    };
    return ButtonGroupComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ButtonGroupComponent.prototype, "size", void 0);
__decorate([
    core_1.ContentChildren(buttongroup_action_component_1.ButtonGroupActionComponent),
    __metadata("design:type", core_1.QueryList)
], ButtonGroupComponent.prototype, "buttonComponentRef", void 0);
ButtonGroupComponent = __decorate([
    core_1.Component({
        selector: 'button-group',
        template: "    \n      <div [class]=\"btnGroupStyleClass\" [attr.id]=\"elementId\">\n        <button *ngFor=\"let data of buttonData\" type=\"button\" (click)=\"buttonClick($event,data)\"\n                [class]=\"data.btnStyleClass\"\n                [attr.fieldName] = \"data.fieldName\"\n                [attr.disabled] = \"data.disabled ? true: null\"\n                data-toggle=\"tooltip\" data-placement=\"bottom\" [attr.title]=\"data.tooltipMessage\"\n        >\n          <ng-container *ngIf=\"data.isLoading\">\n            <span class=\"glyphicon glyphicon-refresh glyphicon-refresh-animate\"></span>&nbsp;&nbsp;&nbsp;\n          </ng-container>\n          {{data.label}}\n          <ng-container *ngIf=\"data.icon!=null\">\n            &nbsp;<span [class]=\"data.iconStyleClass\"></span>\n          </ng-container>\n        </button>\n      </div>\n      <ng-content></ng-content>\n  ",
    }),
    __metadata("design:paramtypes", [])
], ButtonGroupComponent);
exports.ButtonGroupComponent = ButtonGroupComponent;
//# sourceMappingURL=buttongroup.component.js.map