"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var datatable_service_1 = require("./datatable.service");
var column_component_1 = require("./column.component");
var noop = function () {
};
exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DataTableComponent; }),
    multi: true
};
var DataTableComponent = (function () {
    function DataTableComponent(dataTableSevice) {
        this.dataTableSevice = dataTableSevice;
        this.rowSelect = new core_1.EventEmitter();
        this.selectedRowData = new core_1.EventEmitter();
        this.pageNumbers = [];
        this.currentPage = 1;
        this.elementId = "mytable-" + Math.random();
        this.selectAll = false;
        this.selectedRows = [];
        this.isSummary = false;
        this.summaryData = [];
        this.summary = [];
        this.smallScreen = false;
        this.sortBy = -1;
    }
    DataTableComponent.prototype.ngOnInit = function () {
    };
    DataTableComponent.prototype.ngAfterContentInit = function () {
        this.createConfig();
    };
    DataTableComponent.prototype.createConfig = function () {
        this.columns = [];
        this.createColumnConfig();
        for (var ir = 0; ir < this.columns.length; ir++) {
            var column = this.columns[ir];
            if (column.summaryType && column.dataType && column.dataType == "number")
                this.isSummary = true;
            this.summaryData.push(0);
            this.summary.push({ summaryType: column.summaryType, summaryCaption: column.summaryCaption, data: [] });
        }
    };
    DataTableComponent.prototype.createColumnConfig = function () {
        var columnRefArray = [];
        columnRefArray = this.columnRef.toArray();
        for (var cr = 0; cr < columnRefArray.length; cr++) {
            var columnConfig = columnRefArray[cr];
            var columnData = { text: columnConfig.text, dataIndex: columnConfig.dataIndex, hidden: columnConfig.hidden, dataType: columnConfig.dataType };
            if (columnConfig.summaryType) {
                columnData['summaryType'] = columnConfig.summaryType;
            }
            if (columnConfig.summaryCaption) {
                columnData['summaryCaption'] = columnConfig.summaryCaption;
            }
            this.columns.push(columnData);
        }
        console.log(this.columns);
    };
    DataTableComponent.prototype.ngOnChanges = function (change) {
        if (change['dataTableBindData']) {
            var data = change['dataTableBindData'].currentValue;
            if (data) {
                this.setData(data);
            }
        }
    };
    DataTableComponent.prototype.ngAfterViewInit = function () {
        if (this.httpMethod && this.httpUrl) {
            this.dataTableSevice.fetchData(this, this.httpUrl, this.httpMethod);
        }
        else if (this.dataTableBindData) {
            this.setData(this.dataTableBindData);
        }
    };
    DataTableComponent.prototype.setData = function (httpResponse) {
        this.data = this.getResponseData(httpResponse);
        if (this.data.length > (1 * this.pageSize)) {
            this.maxPage = Math.floor((this.data.length / this.pageSize));
            if ((this.data.length % this.pageSize) > 0) {
                this.maxPage++;
            }
        }
        for (var pageNo = 1; pageNo <= this.maxPage; pageNo++) {
            this.pageNumbers.push(pageNo);
        }
        this.createSummaryData();
        this.renderData();
    };
    DataTableComponent.prototype.createSummaryData = function () {
        for (var sd = 0; sd < this.data.length; sd++) {
            var localData = this.data[sd];
            if (this.isSummary) {
                for (var ir = 0; ir < this.columns.length; ir++) {
                    var column = this.columns[ir];
                    if (column.summaryType && column.dataType && column.dataType == "number") {
                        var colData = localData[column.dataIndex];
                        if (colData) {
                            var summaryData = this.summary[ir];
                            if (summaryData && summaryData != "")
                                summaryData.data.push(colData);
                        }
                    }
                }
            }
        }
        for (var is = 0; is < this.summaryData.length; is++) {
            if (this.summaryData[is] == 0) {
                this.summaryData[is] = "";
            }
            var summarized = this.summary[is];
            if (summarized) {
                var summaryType = summarized.summaryType;
                var summarizeData = summarized.data.sort(function (a, b) { return a - b; });
                var summaryCaption = summarized.summaryCaption;
                if (summaryType) {
                    if (summaryType == 'sum') {
                        var sumValue = 0;
                        for (var s = 0; s < summarizeData.length; s++) {
                            sumValue = sumValue + summarizeData[s];
                        }
                        this.summaryData[is] = summaryCaption + " " + sumValue;
                    }
                    else if (summaryType == 'min') {
                        if (summarizeData) {
                            this.summaryData[is] = summaryCaption + " " + summarizeData[0];
                        }
                    }
                    else if (summaryType == 'max') {
                        if (summarizeData) {
                            this.summaryData[is] = summaryCaption + " " + summarizeData[summarizeData.length - 1];
                        }
                    }
                    else if (summaryType == 'avg') {
                        if (summarizeData) {
                            var sumValue = 0;
                            for (var s = 0; s < summarizeData.length; s++) {
                                sumValue = sumValue + summarizeData[s];
                            }
                            this.summaryData[is] = summaryCaption + " " + Math.round(sumValue / summarizeData.length);
                        }
                    }
                }
            }
        }
        console.log(this.summaryData);
    };
    DataTableComponent.prototype.getResponseData = function (httpResponse) {
        var responsedata = httpResponse;
        var dr = this.dataReader.split(".");
        for (var ir = 0; ir < dr.length; ir++) {
            responsedata = responsedata[dr[ir]];
        }
        return responsedata;
    };
    DataTableComponent.prototype.renderData = function () {
        if (this.pageSize > 1) {
            var rowsTemp = this.data;
            var newRows = [];
            var startIndex = 1;
            var endIndex = this.pageSize;
            if (this.currentPage > 1) {
                startIndex = (this.currentPage - 1) * this.pageSize;
                endIndex = startIndex + this.pageSize;
            }
            while (startIndex <= endIndex) {
                if (rowsTemp[startIndex]) {
                    newRows.push(rowsTemp[startIndex]);
                }
                startIndex++;
            }
            this.viewRows = newRows;
        }
        else {
            this.viewRows = this.data;
        }
        this.selectedRowNo = -1;
    };
    DataTableComponent.prototype.sortData = function () {
        if (this.sortColumn) {
            var sortColDataIndex_1;
            var sortOrder_1 = this.sortBy;
            if (this.sortColumn.dataIndex && this.sortColumn.dataType) {
                var dataIndex = this.sortColumn.dataIndex;
                sortColDataIndex_1 = dataIndex;
                if (this.sortColumn.dataType == 'string') {
                    this.data.sort(function (a, b) {
                        var x = a[sortColDataIndex_1].toLowerCase();
                        var y = b[sortColDataIndex_1].toLowerCase();
                        if (sortOrder_1 == 2) {
                            if (x < y) {
                                return 1;
                            }
                            if (x > y) {
                                return -1;
                            }
                        }
                        else {
                            if (x < y) {
                                return -1;
                            }
                            if (x > y) {
                                return 1;
                            }
                        }
                        return 0;
                    });
                }
                else if (this.sortColumn.dataType == 'number') {
                    this.data.sort(function (a, b) {
                        var x = a[sortColDataIndex_1];
                        var y = b[sortColDataIndex_1];
                        if (sortOrder_1 == 2) {
                            return y - x;
                        }
                        else {
                            return x - y;
                        }
                    });
                }
            }
        }
        this.renderData();
    };
    DataTableComponent.prototype.next = function () {
        if (this.currentPage < this.maxPage) {
            this.currentPage++;
        }
        this.renderData();
    };
    DataTableComponent.prototype.prev = function () {
        if (this.currentPage > 1) {
            this.currentPage--;
        }
        else {
            this.currentPage = 1;
        }
        this.renderData();
    };
    DataTableComponent.prototype.sortOnColHeaderClick = function (sortCol) {
        if (this.sortBy == -1)
            this.sortBy = 1;
        else if (this.sortBy == 1)
            this.sortBy = 2;
        else if (this.sortBy == 2)
            this.sortBy = 1;
        this.setSortColumn(sortCol, this.sortBy);
    };
    DataTableComponent.prototype.setSortColumn = function (sortCol, _sortBy) {
        this.sortBy = _sortBy;
        this.sortColumn = sortCol;
        this.sortData();
    };
    DataTableComponent.prototype.setPageNo = function (value) {
        this.currentPage = value;
        this.renderData();
    };
    DataTableComponent.prototype.setUserPageNo = function () {
        this.renderData();
    };
    DataTableComponent.prototype.rowClick = function (rowData, rowIndex) {
        this.rowSelect.emit(rowData);
        this.selectedRowNo = rowIndex;
    };
    DataTableComponent.prototype.isSelected = function (rowNo) {
        return rowNo == this.selectedRowNo;
    };
    DataTableComponent.prototype.setColumnVisiblity = function (dataIndex) {
        for (var ic = 0; ic < this.columns.length; ic++) {
            var col = this.columns[ic];
            if (col.dataIndex == dataIndex) {
                col.hidden = !col.hidden;
            }
        }
    };
    DataTableComponent.prototype.selectAllVisibleRows = function () {
        this.selectAll = !this.selectAll;
        if (this.selectAll) {
            for (var vr = 0; vr < this.viewRows.length; vr++) {
                this.selectedRows.push(this.viewRows[vr]);
            }
        }
        else {
            this.selectedRows = [];
        }
        this.emitSelectedRows();
    };
    DataTableComponent.prototype.setSelectedRow = function (rowData, event) {
        if (event.currentTarget.checked) {
            this.selectedRows.push(rowData);
        }
        else {
            var indexOf = this.selectedRows.indexOf(rowData);
            delete this.selectedRows[indexOf];
        }
        this.emitSelectedRows();
    };
    DataTableComponent.prototype.emitSelectedRows = function () {
        var sRows = [];
        for (var sr = 0; sr < this.selectedRows.length; sr++) {
            if (this.selectedRows[sr]) {
                sRows.push(this.selectedRows[sr]);
            }
        }
        this.selectedRowData.emit(sRows);
    };
    DataTableComponent.prototype.onResize = function (event) {
        if (event.target.innerWidth < 768) {
            this.smallScreen = true;
        }
        else {
            this.smallScreen = false;
        }
        console.log(this.smallScreen);
    };
    return DataTableComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "title", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], DataTableComponent.prototype, "pageSize", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "httpUrl", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "httpMethod", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "dataReader", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DataTableComponent.prototype, "checkboxSelect", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "dataTableBindData", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "rowSelect", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "selectedRowData", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "height", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "width", void 0);
__decorate([
    core_1.ContentChildren(column_component_1.ColumnComponent),
    __metadata("design:type", core_1.QueryList)
], DataTableComponent.prototype, "columnRef", void 0);
DataTableComponent = __decorate([
    core_1.Component({
        selector: 'data-table',
        template: "\n        <div>\n            <ng-content></ng-content>\n        </div>\n\n        <table class=\"table table-hover table-striped table-bordered\"  [attr.id]=\"elementId\" (window:resize)=\"onResize($event)\">\n            <thead>\n\n              <tr>\n                  <td [attr.colspan]=\"columns.length + (checkboxSelect? 1: 0)\" width=\"100%\" data align=\"right\">\n                    <span style=\"float: left;\">\n                      <b>{{title}}</b>\n                    </span>\n                    <span style=\"float: right\">\n                       <div class=\"btn-group\">\n                        <button type=\"button\" class=\"btn btn-default\" aria-label=\"Previous\" (click)=\"prev()\">\n                          <span aria-hidden=\"true\">&laquo;</span>\n                        </button>\n        \n                        <button type=\"button\" class=\"btn btn-default\">\n                          <span> ({{currentPage}} of {{maxPage}})</span>\n                        </button>\n        \n                        <div class=\"btn-group\" role=\"group\">\n                          <button type=\"button\" class=\"btn btn-default dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\">\n                            Page - {{currentPage}}\n                            <span class=\"caret\"></span>\n                          </button>\n                          <ul class=\"dropdown-menu  dropdown-menu-right\">\n                              <li *ngFor=\"let row of pageNumbers let pageNo = index \" value=\"{{pageNo+1}}\"><a (click)=\"setPageNo(pageNo+1)\">{{pageNo+1}}</a></li>\n                          </ul>\n                        </div>\n        \n                        <div class=\"btn-group\" role=\"group\">\n                          <button type=\"button\" class=\"btn btn-default dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\">\n                            <span class=\"glyphicon glyphicon-th-list\"></span>\n                          </button>\n                          <ul class=\"dropdown-menu  dropdown-menu-right\">\n                              <li>\n                                  &nbsp;&nbsp;<b> Show Columns</b>\n                              </li>\n                              <li *ngFor=\"let cols of columns\">\n                                  <div class=\"checkbox\">\n                                      <label>\n                                          &nbsp;&nbsp;<input type=\"checkbox\" (click)=\"setColumnVisiblity(cols.dataIndex)\" [attr.checked]=\"!cols.hidden ? true: null\"> {{cols.text +\" \"}}\n                                      </label>\n                                  </div>\n                              </li>\n                          </ul>\n                        </div>\n                        <button type=\"button\" class=\"btn btn-default\" aria-label=\"Next\" (click)=\"next()\"><span aria-hidden=\"true\">&raquo;</span></button>\n                      </div>\n                    </span>\n                  </td>\n              </tr>\n  \n              <tr *ngIf=\"!smallScreen\">\n                  <td *ngIf=\"checkboxSelect\" width=\"5%\"><input type=\"checkbox\" (click)=\"selectAllVisibleRows()\" ></td>\n                  <td *ngFor=\"let cols of columns\" [hidden]=\"cols.hidden\" >\n                      <span style=\"cursor: pointer;\" (click)=\"sortOnColHeaderClick(cols)\"><b>{{cols.text}}</b></span>\n                      <span  style=\"float: right\" class=\"btn-group\" role=\"group\">\n                        <span class=\"dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\">\n                          <span class=\"glyphicon glyphicon-triangle-bottom\" style=\"color:#93a1a1\"></span>\n                        </span>\n                        <div class=\"dropdown-menu\">\n                            <button class=\"btn btn-link\" (click)=\"setSortColumn(cols,1)\">\n                                <span class=\"glyphicon glyphicon glyphicon-sort-by-attributes pull-left\"></span><span>&nbsp;Sort Ascending</span>\n                            </button>                          \n                            <button class=\"btn btn-link\" (click)=\"setSortColumn(cols,2)\">\n                                <span class=\"glyphicon glyphicon glyphicon glyphicon-sort-by-attributes-alt pull-left\"></span><span>&nbsp;Sort Descending</span>\n                            </button>                          \n                        </div>\n                      </span>\n                  </td>\n              </tr>\n              \n              <tr  *ngIf=\"!smallScreen\">\n                  <td *ngIf=\"checkboxSelect\"  width=\"5%\"></td>\n                  <td *ngFor=\"let cols of columns let colIndex = index \" [hidden] =\"cols.hidden\" >\n                      <b>{{summaryData[colIndex]}}</b>\n                  </td>\n              </tr>\n            \n            </thead>\n          \n            <tbody *ngIf=\"!smallScreen\">\n            \n              <tr style=\"cursor: pointer\" *ngFor=\"let row of viewRows let rowIndex = index \" (click)=\"rowClick(row, rowIndex)\" [class.info]=\"isSelected(rowIndex)\">\n                  <td *ngIf=\"checkboxSelect\"  width=\"5%\"><input type=\"checkbox\" id=\"checkbox-{{elementId}}-{{rowIndex}}\" [attr.checked]=\"selectAll? true: null\" (click)=\"setSelectedRow(row, $event)\"></td>\n                  <td *ngFor=\"let cols of columns\" [hidden] =\"cols.hidden\" >\n                      {{row[cols.dataIndex]}}\n                  </td>\n              </tr>\n            \n            </tbody>\n          \n            <tbody *ngIf=\"smallScreen\">\n                <tr style=\"cursor: pointer\" *ngFor=\"let row of viewRows let rowIndex = index \" (click)=\"rowClick(row, rowIndex)\" [class.info]=\"isSelected(rowIndex)\">\n                  <td *ngIf=\"checkboxSelect\"  width=\"5%\"><input type=\"checkbox\" id=\"checkbox-{{elementId}}-{{rowIndex}}\" [attr.checked]=\"selectAll? true: null\" (click)=\"setSelectedRow(row, $event)\"></td>\n                  <td>\n                    <div style=\"word-wrap: break-word\" *ngFor=\"let cols of columns\" [hidden] =\"cols.hidden\" >\n                      <b>{{cols.text}}</b> : {{row[cols.dataIndex]}}\n                    </div>\n                  </td>\n                </tr>\n            </tbody>\n\n        </table>\n    ",
        providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR, datatable_service_1.DataTableService]
    }),
    __metadata("design:paramtypes", [datatable_service_1.DataTableService])
], DataTableComponent);
exports.DataTableComponent = DataTableComponent;
//# sourceMappingURL=datatable.component.js.map