"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var dropdown_service_1 = require("./dropdown.service");
var forms_1 = require("@angular/forms");
var form_input_base_1 = require("../baseclass/form.input.base");
var noop = function () {
};
exports.CUSTOM_DROPDOWN_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DropDownComponent; }),
    multi: true
};
exports.BASE_IMPL_DROPDOWN_INPUT = {
    provide: form_input_base_1.FormInputBase,
    useExisting: core_1.forwardRef(function () { return DropDownComponent; })
};
var DropDownComponent = (function (_super) {
    __extends(DropDownComponent, _super);
    function DropDownComponent(dropDownService) {
        var _this = _super.call(this) || this;
        _this.dropDownService = dropDownService;
        _this.onSingleSelect = new core_1.EventEmitter();
        _this.onMultiSelect = new core_1.EventEmitter();
        _this.multiSelectValues = [];
        //The internal dataviews model
        _this.innerValue = '';
        //Placeholders for the callbacks which are later provided
        //by the Control Value Accessor
        _this.onTouchedCallback = noop;
        _this.onChangeCallback = noop;
        _this.elementId = 'dropdown-' + new Date().getTime() + Math.floor(Math.random() * 90000) + 10000;
        return _this;
    }
    DropDownComponent.prototype.ngOnInit = function () {
        if (this.httpMethod && this.httpUrl) {
            this.dropDownService.fetchData(this, this.httpUrl, this.httpMethod);
        }
        else if (this.data) {
            this.setData(this.data);
        }
    };
    DropDownComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $('#' + this.elementId).on('changed.bs.select', function (e, clickedIndex, newValue, oldValue) {
            // Check if multi option is on? then load on array avoiding duplicates
            if (_this.multiSelect) {
                _this.addMultiSelectedData(_this.viewData[clickedIndex]);
            }
            else {
                _this.addSingleSelectedData(_this.viewData[clickedIndex - 1]);
            }
        });
    };
    DropDownComponent.prototype.ngAfterViewChecked = function () {
        $('#' + this.elementId).selectpicker('refresh'); // TODO : Check Performance??
    };
    DropDownComponent.prototype.ngOnDestroy = function () {
        $('#' + this.elementId).selectpicker('destroy');
    };
    DropDownComponent.prototype.setRowData = function (event) {
    };
    DropDownComponent.prototype.addSingleSelectedData = function (value) {
        this.onSingleSelect.emit({ data: value });
    };
    DropDownComponent.prototype.addMultiSelectedData = function (val) {
        if (this.multiSelectValues.indexOf(val) > -1) {
            this.multiSelectValues = this.multiSelectValues.filter(function (item) { return item !== val; });
        }
        else {
            this.multiSelectValues.push(val);
        }
        this.onMultiSelect.emit({ data: this.multiSelectValues });
    };
    DropDownComponent.prototype.setData = function (httpResponse) {
        var responsedata = httpResponse;
        var dr = this.dataReader.split(".");
        for (var ir = 0; ir < dr.length; ir++) {
            responsedata = responsedata[dr[ir]];
        }
        this.viewData = responsedata;
    };
    Object.defineProperty(DropDownComponent.prototype, "value", {
        //get accessor
        get: function () {
            return this.innerValue;
        },
        //set accessor including call the onchange callback
        set: function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    //Set touched on blur
    DropDownComponent.prototype.onBlur = function () {
        this.onTouchedCallback();
        this.validate();
    };
    //From ControlValueAccessor interface
    DropDownComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    //From ControlValueAccessor interface
    DropDownComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    //From ControlValueAccessor interface
    DropDownComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    DropDownComponent.prototype.validate = function () {
        this.isValid = this.isValidInput();
    };
    DropDownComponent.prototype.isValidInput = function () {
        var hasError = false;
        /*let valueLength = 0;
         if(this.value !=null){
         valueLength = this.value.length;
         }
         if((this.allowBlank && (!this.value || this.value.length==0))){
         hasError = true;
         }else {
         let cmp : any = document.getElementById(this.elementId);
         hasError = !cmp.validity.valid;
         }
         if(hasError){
         this.setValidClassNames();
         }else{
         this.setInvalidatedClassNames();
         }
         */
        return hasError;
    };
    return DropDownComponent;
}(form_input_base_1.FormInputBase));
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "fieldLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "placeholder", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "fieldName", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "allowBlank", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "errorMsg", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "emptyText", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DropDownComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "dataReader", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "httpMethod", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "httpUrl", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "displayField", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "valueField", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], DropDownComponent.prototype, "data", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DropDownComponent.prototype, "multiSelect", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "maxMultiSelect", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DropDownComponent.prototype, "multiSelectHelp", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DropDownComponent.prototype, "searchBox", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "multiCountDisplay", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "width", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], DropDownComponent.prototype, "onSingleSelect", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], DropDownComponent.prototype, "onMultiSelect", void 0);
DropDownComponent = __decorate([
    core_1.Component({
        selector: 'drop-down',
        template: "\n      <label [attr.for]=\"elementId\">{{fieldLabel}}</label>\n      <select class=\"selectpicker form-control\"\n              [title]=\"placeholder\"\n              (blur)=\"onBlur()\"\n              [(ngModel)]=\"value\"\n              [attr.id]=\"elementId\"\n              [attr.multiple]=\"multiSelect ? 'multiple' : null\"\n              [attr.data-live-search]=\"searchBox ? 'true' : null\"\n              [attr.data-max-options]=\"maxMultiSelect\"\n              [attr.data-actions-box]=\"multiSelectHelp ? 'true' : null\"\n              [attr.data-selected-text-format]=\"multiCountDisplay\"\n              [attr.data-width]=\"width\"\n              (change)=\"setRowData($event)\">\n          <option *ngFor=\"let row of viewData\" [attr.value]=\"row[valueField]\">{{row[displayField]}}</option>\n      </select>\n\n  ",
        providers: [dropdown_service_1.DropDownService, exports.CUSTOM_DROPDOWN_CONTROL_VALUE_ACCESSOR, exports.BASE_IMPL_DROPDOWN_INPUT]
    }),
    __metadata("design:paramtypes", [dropdown_service_1.DropDownService])
], DropDownComponent);
exports.DropDownComponent = DropDownComponent;
//# sourceMappingURL=dropdown.component.js.map