"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var dropdown_service_1 = require("./dropdown.service");
var noop = function () {
};
exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return DropDownComponent; }),
    multi: true
};
var DropDownComponent = (function () {
    function DropDownComponent(dropDownService) {
        this.dropDownService = dropDownService;
        this.selectedValue = new core_1.EventEmitter();
        //The internal data model
        this.innerValue = '';
        //Placeholders for the callbacks which are later provided
        //by the Control Value Accessor
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
        this.elementId = "drop-down-" + new Date().getTime();
    }
    DropDownComponent.prototype.ngOnInit = function () {
        this.selectedDisplayField = this.emptyText;
    };
    DropDownComponent.prototype.ngOnChanges = function (changes) {
        if (changes.dropDownBindData) {
            var data = changes.dropDownBindData.currentValue;
            if (data) {
                this.setData(data);
            }
        }
    };
    DropDownComponent.prototype.ngAfterViewInit = function () {
        if (this.httpMethod && this.httpUrl) {
            this.dropDownService.fetchData(this, this.httpUrl, this.httpMethod);
        }
        else if (this.dropDownBindData) {
            this.setData(this.dropDownBindData);
        }
    };
    DropDownComponent.prototype.setData = function (httpResponse) {
        this.viewData = this.getResponseData(httpResponse);
        this.data = this.getResponseData(httpResponse);
    };
    DropDownComponent.prototype.getResponseData = function (httpResponse) {
        var responsedata = httpResponse;
        var dr = this.dataReader.split(".");
        for (var ir = 0; ir < dr.length; ir++) {
            responsedata = responsedata[dr[ir]];
        }
        return responsedata;
    };
    Object.defineProperty(DropDownComponent.prototype, "value", {
        //get accessor
        get: function () {
            return this.innerValue;
        },
        //set accessor including call the onchange callback
        set: function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    //Set touched on blur
    DropDownComponent.prototype.onBlur = function () {
        this.onTouchedCallback();
    };
    //From ControlValueAccessor interface
    DropDownComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    //From ControlValueAccessor interface
    DropDownComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    //From ControlValueAccessor interface
    DropDownComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    DropDownComponent.prototype.setSelectedValue = function (selectedData) {
        this.selectedDisplayField = selectedData[this.displayField];
        this.selectedValueField = selectedData[this.valueField];
        this.selectedValue.emit(this.selectedValueField);
    };
    DropDownComponent.prototype.filterData = function (event) {
        console.log(this.textValue);
        if (this.textValue.length > 0) {
            this.viewData = [];
            for (var vd = 0; vd < this.data.length; vd++) {
                var displayData = this.data[vd][this.displayField];
                if (displayData.toLowerCase().startsWith(this.textValue)) {
                    this.viewData.push(this.data[vd]);
                }
            }
        }
        else {
            this.viewData = this.data;
        }
    };
    return DropDownComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "fieldLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "fieldName", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "allowBlank", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "errorMsg", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "emptyText", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], DropDownComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "dataReader", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "httpMethod", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "httpUrl", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "displayField", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], DropDownComponent.prototype, "valueField", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], DropDownComponent.prototype, "dropDownBindData", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], DropDownComponent.prototype, "selectedValue", void 0);
DropDownComponent = __decorate([
    core_1.Component({
        selector: 'drop-down',
        templateUrl: 'drop-down.html',
        providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR, dropdown_service_1.DropDownService]
    }),
    __metadata("design:paramtypes", [dropdown_service_1.DropDownService])
], DropDownComponent);
exports.DropDownComponent = DropDownComponent;
//# sourceMappingURL=dropdown.js.map