"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var form_input_base_1 = require("../baseclass/form.input.base");
var noop = function () {
};
exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return EmailInputComponent; }),
    multi: true
};
exports.BASE_IMPL_EMAIL_INPUT = {
    provide: form_input_base_1.FormInputBase,
    useExisting: core_1.forwardRef(function () { return EmailInputComponent; })
};
var EmailInputComponent = (function (_super) {
    __extends(EmailInputComponent, _super);
    function EmailInputComponent() {
        var _this = _super.call(this) || this;
        _this.hasLabel = true;
        //The internal data model
        _this.innerValue = '';
        //Placeholders for the callbacks which are later provided
        //by the Control Value Accessor
        _this.onTouchedCallback = noop;
        _this.onChangeCallback = noop;
        _this.elementId = 'input-email-' + new Date().getTime() + Math.random();
        _this.spanId = 'span-msg-' + Math.random();
        if (_this.iconFeedBack)
            _this.divCss = 'form-group has-feedback';
        else
            _this.divCss = 'form-group has-feedback has-feedback-left';
        return _this;
    }
    EmailInputComponent.prototype.ngOnInit = function () {
        if (this.errorMsg)
            this.helpInfoMsg = this.errorMsg + '<br/>';
    };
    Object.defineProperty(EmailInputComponent.prototype, "value", {
        //get accessor
        get: function () {
            return this.innerValue;
        },
        //set accessor including call the onchange callback
        set: function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    //Set touched on blur
    EmailInputComponent.prototype.onBlur = function () {
        this.onTouchedCallback();
        this.validate();
    };
    //From ControlValueAccessor interface
    EmailInputComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    //From ControlValueAccessor interface
    EmailInputComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    //From ControlValueAccessor interface
    EmailInputComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    EmailInputComponent.prototype.validate = function () {
        this.isValid = this.isValidInput();
    };
    EmailInputComponent.prototype.isValidInput = function () {
        var hasError = false;
        var valueLength = 0;
        if (this.value != null) {
            valueLength = this.value.length;
        }
        if ((this.allowBlank && (!this.value || this.value.length == 0))) {
            hasError = true;
        }
        else {
            var cmp = document.getElementById(this.elementId);
            hasError = !cmp.validity.valid;
        }
        debugger;
        if (hasError) {
            this.setValidClassNames();
        }
        else {
            this.setInvalidatedClassNames();
        }
        return hasError;
    };
    EmailInputComponent.prototype.setValidClassNames = function () {
        this.divCss = 'form-group has-error has-feedback';
        this.iconName = 'error';
        this.iconClassName = 'glyphicon glyphicon-remove form-control-feedback';
    };
    EmailInputComponent.prototype.setInvalidatedClassNames = function () {
        this.divCss = 'form-group has-success has-feedback';
        this.iconName = 'success';
        this.iconClassName = 'glyphicon glyphicon-ok form-control-feedback';
    };
    return EmailInputComponent;
}(form_input_base_1.FormInputBase));
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "fieldLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "fieldName", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "allowBlank", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "errorMsg", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "placeholder", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], EmailInputComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], EmailInputComponent.prototype, "iconFeedBack", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "fontStyle", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "fontFamily", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "fontSize", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], EmailInputComponent.prototype, "fieldIcon", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], EmailInputComponent.prototype, "hasLabel", void 0);
EmailInputComponent = __decorate([
    core_1.Component({
        selector: 'email-input',
        templateUrl: 'emailinput.html',
        providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR, exports.BASE_IMPL_EMAIL_INPUT]
    }),
    __metadata("design:paramtypes", [])
], EmailInputComponent);
exports.EmailInputComponent = EmailInputComponent;
//# sourceMappingURL=emailinput.js.map