"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var form_input_base_1 = require("../baseclass/form.input.base");
var noop = function () {
};
exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return PasswordInputComponent; }),
    multi: true
};
exports.BASE_IMPL_PASSWORD_INPUT = {
    provide: form_input_base_1.FormInputBase,
    useExisting: core_1.forwardRef(function () { return PasswordInputComponent; })
};
var PasswordInputComponent = (function (_super) {
    __extends(PasswordInputComponent, _super);
    function PasswordInputComponent() {
        var _this = _super.call(this) || this;
        //The internal dataviews model
        _this.innerValue = '';
        //Placeholders for the callbacks which are later provided
        //by the Control Value Accessor
        _this.onTouchedCallback = noop;
        _this.onChangeCallback = noop;
        _this.elementId = 'input-text-' + new Date().getTime() + Math.random();
        _this.spanId = 'span-msg-' + Math.random();
        if (_this.iconFeedBack)
            _this.divCss = 'form-group has-feedback';
        else
            _this.divCss = 'form-group has-feedback has-feedback-left';
        return _this;
    }
    PasswordInputComponent.prototype.ngOnInit = function () {
        if (this.errorMsg)
            this.helpInfoMsg = this.errorMsg + '<br/>';
        if (this.minErrorMsg)
            this.helpInfoMsg = this.helpInfoMsg + 'Min Length: ' + this.minErrorMsg + '<br/>';
        if (this.maxErrorMsg)
            this.helpInfoMsg = this.helpInfoMsg + 'Max Length: ' + this.maxErrorMsg;
        if (!this.iconFeedBack)
            this.fieldglyphIcon = 'form-control-feedback glyphicon glyphicon-' + this.fieldIcon;
    };
    Object.defineProperty(PasswordInputComponent.prototype, "value", {
        //get accessor
        get: function () {
            return this.innerValue;
        },
        //set accessor including call the onchange callback
        set: function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    //Set touched on blur
    PasswordInputComponent.prototype.onBlur = function () {
        this.onTouchedCallback();
        this.validate();
    };
    //From ControlValueAccessor interface
    PasswordInputComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    //From ControlValueAccessor interface
    PasswordInputComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    //From ControlValueAccessor interface
    PasswordInputComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    PasswordInputComponent.prototype.validate = function () {
        this.isValid = this.isValidInput();
    };
    PasswordInputComponent.prototype.isValidInput = function () {
        var hasError = false;
        if ((this.allowBlank && (!this.value || this.value.length == 0))) {
            hasError = true;
        }
        else if (this.minLength > this.value.length) {
            hasError = true;
        }
        else if (this.maxLength < this.value.length) {
            hasError = true;
        }
        if (hasError) {
            this.setValidClassNames();
        }
        else {
            this.setInvalidatedClassNames();
        }
        return hasError;
    };
    PasswordInputComponent.prototype.setValidClassNames = function () {
        this.divCss = 'form-group has-error has-feedback';
        this.iconName = 'error';
        this.iconClassName = 'glyphicon glyphicon-remove form-control-feedback';
    };
    PasswordInputComponent.prototype.setInvalidatedClassNames = function () {
        this.divCss = 'form-group has-success has-feedback';
        this.iconName = 'success';
        this.iconClassName = 'glyphicon glyphicon-ok form-control-feedback';
    };
    return PasswordInputComponent;
}(form_input_base_1.FormInputBase));
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "fieldLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "fieldName", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], PasswordInputComponent.prototype, "minLength", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "minErrorMsg", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], PasswordInputComponent.prototype, "maxLength", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "maxErrorMsg", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "allowBlank", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "errorMsg", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "placeholder", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], PasswordInputComponent.prototype, "disabled", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], PasswordInputComponent.prototype, "iconFeedBack", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "fontStyle", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "fontFamily", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "fontSize", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], PasswordInputComponent.prototype, "fieldIcon", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], PasswordInputComponent.prototype, "hasLabel", void 0);
PasswordInputComponent = __decorate([
    core_1.Component({
        selector: 'password-input',
        template: "\n\n        <div [attr.class]=\"divCss\">\n\n            <ng-container *ngIf=\"hasLabel\">\n                <label [attr.for]=\"elementId\"\n                       [style.font-style]=\"fontStyle\"\n                       [style.font-family]=\"fontFamily\"\n                       [style.font-size]=\"fontSize\"\n                       class=\"control-label\">\n                    {{fieldLabel}}\n                </label>\n            </ng-container>\n\n            <input type=\"password\"\n                   (blur)=\"onBlur()\"\n                   autocomplete=\"off\"\n                   class=\"form-control\"\n                   [(ngModel)]=\"value\"\n                   [attr.fieldName] = \"fieldName\"\n                   [attr.id]=\"elementId\"\n                   [attr.placeholder]=\"placeholder\"\n                   [attr.maxLength]=\"maxLength\"\n                   [attr.minLength]=\"minLength\"\n                   [attr.disabled] = \"disabled ? true: null\"\n                   [required]=\"allowBlank ? true: null\"\n                   [attr.data-error]=\"errorMsg\"\n                   [attr.aria-describedby]=\"spanId\"\n                   data-toggle=\"popover\" title=\"Info\" data-placement=\"bottom\"  data-trigger=\"focus\"  data-html=\"true\"  [attr.data-content]=\"helpInfoMsg\"\n            >\n            <ng-container *ngIf=\"iconFeedBack\">\n                <span [attr.class]=\"iconClassName\" aria-hidden=\"true\"></span>\n                <span [attr.id]=\"spanId\" class=\"sr-only\">({{iconName}})</span>\n            </ng-container>\n\n            <ng-container *ngIf=\"!iconFeedBack\">\n                <i [class]=\"fieldglyphIcon\"></i>\n            </ng-container>\n\n            <div class=\"help-block with-errors\"></div>\n\n        </div>\n\n    ",
        providers: [exports.CUSTOM_INPUT_CONTROL_VALUE_ACCESSOR, exports.BASE_IMPL_PASSWORD_INPUT]
    }),
    __metadata("design:paramtypes", [])
], PasswordInputComponent);
exports.PasswordInputComponent = PasswordInputComponent;
//# sourceMappingURL=passwordinput.component.js.map