"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var radiogroup_service_1 = require("./radiogroup.service");
exports.COLUMN_SIZE = 'col-lg-';
var RadioGroupComponent = (function () {
    function RadioGroupComponent(radioGroupService) {
        this.radioGroupService = radioGroupService;
        this.selectedValue = new core_1.EventEmitter();
        this.elementId = "radio-group-" + new Date().getTime();
        this.selectedCheckBox = [];
    }
    RadioGroupComponent.prototype.ngOnInit = function () {
    };
    RadioGroupComponent.prototype.ngAfterViewInit = function () {
        this.column = exports.COLUMN_SIZE + this.column;
        if (this.httpMethod && this.httpUrl) {
            this.radioGroupService.fetchData(this, this.httpUrl, this.httpMethod);
        }
        else if (this.radioGroupBindData) {
            this.setData(this.radioGroupBindData);
        }
    };
    RadioGroupComponent.prototype.setData = function (httpResponse) {
        this.data = this.getResponseData(httpResponse);
        this.viewData = this.getResponseData(httpResponse);
    };
    RadioGroupComponent.prototype.getResponseData = function (httpResponse) {
        var responsedata = httpResponse;
        var dr = this.dataReader.split(".");
        if (dr != null) {
            for (var ir = 0; ir < dr.length; ir++) {
                responsedata = responsedata[dr[ir]];
            }
        }
        return responsedata;
    };
    RadioGroupComponent.prototype.filterData = function (event) {
        if (this.textValue.length > 0) {
            this.viewData = [];
            for (var vd = 0; vd < this.data.length; vd++) {
                var displayData = this.data[vd][this.displayField];
                if (displayData.toLowerCase().startsWith(this.textValue)) {
                    this.viewData.push(this.data[vd]);
                }
            }
        }
        else {
            this.viewData = this.data;
        }
    };
    RadioGroupComponent.prototype.setSelectedCheckBox = function (rowData, event) {
        if (event.currentTarget.checked) {
            this.selectedCheckBox.push(rowData);
        }
        else {
            var indexOf = this.selectedCheckBox.indexOf(rowData);
            delete this.selectedCheckBox[indexOf];
        }
        this.emitSelectedRows();
    };
    RadioGroupComponent.prototype.emitSelectedRows = function () {
        var sRows = [];
        for (var sr = 0; sr < this.selectedCheckBox.length; sr++) {
            if (this.selectedCheckBox[sr]) {
                sRows.push(this.selectedCheckBox[sr]);
            }
        }
        this.selectedValue.emit(sRows);
    };
    return RadioGroupComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RadioGroupComponent.prototype, "fieldLabel", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RadioGroupComponent.prototype, "fieldName", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], RadioGroupComponent.prototype, "allowBlank", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RadioGroupComponent.prototype, "dataReader", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RadioGroupComponent.prototype, "httpMethod", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RadioGroupComponent.prototype, "httpUrl", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RadioGroupComponent.prototype, "displayField", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RadioGroupComponent.prototype, "valueField", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], RadioGroupComponent.prototype, "radioGroupBindData", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], RadioGroupComponent.prototype, "searchBox", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RadioGroupComponent.prototype, "column", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], RadioGroupComponent.prototype, "selectedValue", void 0);
RadioGroupComponent = __decorate([
    core_1.Component({
        selector: 'radio-group',
        template: "\n      <div class=\"form-group\">\n          <br>\n          <label  [attr.for]=\"elementId\">{{fieldLabel}}</label>\n          <div style=\"overflow: auto;\">\n              <ul class=\"list-group\">\n                  <li class=\"list-group-item\" *ngIf=\"searchBox\"><span>\n              <input [(ngModel)]=\"textValue\" type=\"text\" class=\"form-control\" placeholder=\"Please select\" (keyup)=\"filterData($event)\">\n            </span></li>\n                  <li [attr.class]=\"'list-group-item '+column\"  *ngFor=\"let row of viewData\">\n                      <label>\n                          <input  type=\"radio\" [required]=\"allowBlank ? true: null\"  [attr.name] = \"fieldName\" (click)=\"setSelectedCheckBox(row, $event)\"> {{row[displayField]}}\n                      </label>\n                  </li>\n              </ul>\n          </div>\n\n\n      </div>\n\n  ",
        providers: [radiogroup_service_1.RadioGroupService]
    }),
    __metadata("design:paramtypes", [radiogroup_service_1.RadioGroupService])
], RadioGroupComponent);
exports.RadioGroupComponent = RadioGroupComponent;
//# sourceMappingURL=radiogroup.component.js.map