"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var form_input_base_1 = require("../baseclass/form.input.base");
exports.RATING_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return RatingInputComponent; }),
    multi: true
};
exports.BASE_IMPL_RATING_INPUT = {
    provide: form_input_base_1.FormInputBase,
    useExisting: core_1.forwardRef(function () { return RatingInputComponent; })
};
var RatingInputComponent = (function (_super) {
    __extends(RatingInputComponent, _super);
    function RatingInputComponent() {
        var _this = _super.call(this) || this;
        _this.max = 5;
        _this.onChange = Function.prototype;
        _this.onTouched = Function.prototype;
        return _this;
    }
    RatingInputComponent.prototype.hoveringOver = function (value) {
        this.overStar = value;
        this.percent = 100 * (value / this.max);
    };
    ;
    RatingInputComponent.prototype.resetStar = function () {
        this.overStar = void 0;
    };
    RatingInputComponent.prototype.onKeydown = function (event) {
        if ([37, 38, 39, 40].indexOf(event.which) === -1) {
            return;
        }
        event.preventDefault();
        event.stopPropagation();
        var sign = event.which === 38 || event.which === 39 ? 1 : -1;
        this.rate(this.value + sign);
    };
    RatingInputComponent.prototype.ngOnInit = function () {
        this.max = typeof this.max !== 'undefined' ? this.max : 5;
        this.readonly = this.readonly === true;
        this.stateOn = typeof this.stateOn !== 'undefined'
            ? this.stateOn
            : 'glyphicon-star';
        this.stateOff = typeof this.stateOff !== 'undefined'
            ? this.stateOff
            : 'glyphicon-star-empty';
        this.titles = typeof this.titles !== 'undefined' && this.titles.length > 0
            ? this.titles
            : ['one', 'two', 'three', 'four', 'five'];
        this.range = this.buildTemplateObjects(this.ratingStates, this.max);
    };
    // model -> view
    RatingInputComponent.prototype.writeValue = function (value) {
        if (value % 1 !== value) {
            this.value = Math.round(value);
            this.preValue = value;
            return;
        }
        this.preValue = value;
        this.value = value;
    };
    RatingInputComponent.prototype.enter = function (value) {
        if (!this.readonly) {
            this.value = value;
            this.hoveringOver(value);
        }
    };
    RatingInputComponent.prototype.reset = function () {
        this.value = this.preValue;
        this.resetStar();
    };
    RatingInputComponent.prototype.registerOnChange = function (fn) {
        this.onChange = fn;
    };
    RatingInputComponent.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    RatingInputComponent.prototype.rate = function (value) {
        if (!this.readonly && value >= 0 && value <= this.range.length) {
            this.writeValue(value);
            this.onChange(value);
        }
    };
    RatingInputComponent.prototype.buildTemplateObjects = function (ratingStates, max) {
        ratingStates = ratingStates || [];
        var count = ratingStates.length || max;
        var result = [];
        for (var i = 0; i < count; i++) {
            result.push(Object.assign({
                index: i,
                stateOn: this.stateOn,
                stateOff: this.stateOff,
                title: this.titles[i] || i + 1
            }, ratingStates[i] || {}));
        }
        return result;
    };
    RatingInputComponent.prototype.isValidInput = function () {
        return true; //for now
    };
    return RatingInputComponent;
}(form_input_base_1.FormInputBase));
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], RatingInputComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RatingInputComponent.prototype, "stateOn", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], RatingInputComponent.prototype, "stateOff", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], RatingInputComponent.prototype, "readonly", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Array)
], RatingInputComponent.prototype, "titles", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Array)
], RatingInputComponent.prototype, "ratingStates", void 0);
__decorate([
    core_1.HostListener('keydown', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], RatingInputComponent.prototype, "onKeydown", null);
RatingInputComponent = __decorate([
    core_1.Component({
        selector: 'rating-input',
        templateUrl: 'ratinginput.html',
        providers: [exports.RATING_CONTROL_VALUE_ACCESSOR, exports.BASE_IMPL_RATING_INPUT]
    }),
    __metadata("design:paramtypes", [])
], RatingInputComponent);
exports.RatingInputComponent = RatingInputComponent;
//# sourceMappingURL=ratinginput.js.map