"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var scrollview_service_1 = require("./scrollview.service");
var ScrollViewComponent = (function () {
    function ScrollViewComponent(scrollViewService) {
        this.scrollViewService = scrollViewService;
        this.isContent = false;
        this.elementId = 'scroll' + Math.round(Math.random() * 200);
    }
    ScrollViewComponent.prototype.ngOnInit = function () {
    };
    ScrollViewComponent.prototype.ngAfterViewInit = function () {
        if (this.httpMethod && this.httpUrl) {
            this.scrollViewService.fetchData(this, this.httpUrl, this.httpMethod);
        }
        else if (this.scrollViewBindData) {
            this.setData(this.scrollViewBindData);
        }
    };
    ScrollViewComponent.prototype.setData = function (httpResponse) {
        var scrolldata = this.getResponseData(httpResponse);
        if (scrolldata) {
            this.data = scrolldata;
        }
    };
    ScrollViewComponent.prototype.getResponseData = function (httpResponse) {
        var responsedata = httpResponse;
        var dr = this.dataReader.split(".");
        for (var ir = 0; ir < dr.length; ir++) {
            responsedata = responsedata[dr[ir]];
        }
        return responsedata;
    };
    return ScrollViewComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ScrollViewComponent.prototype, "httpUrl", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ScrollViewComponent.prototype, "httpMethod", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], ScrollViewComponent.prototype, "dataReader", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], ScrollViewComponent.prototype, "scrollViewBindData", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], ScrollViewComponent.prototype, "isContent", void 0);
ScrollViewComponent = __decorate([
    core_1.Component({
        selector: 'scroll-view',
        template: "\n\n      <div [attr.id]=\"elementId\" class=\"carousel slide\" data-ride=\"carousel\">\n          <!-- Indicators -->\n          <ol class=\"carousel-indicators\">\n              <li *ngFor=\"let scroll of data;let i =index\"  [attr.data-target]=\"'#'+elementId\" [attr.data-slide-to]=\"i\" class=\"active\" [ngClass]=\"{'active':scroll.active}\"></li>\n          </ol>\n          <!-- Wrapper for slides -->\n          <div class=\"carousel-inner\">\n              <div class=\"item\" [ngClass]=\"{'active':scrollData.active}\"  *ngFor=\"let scrollData of data\" >\n                  <div class=\"text-center\">{{scrollData.title}}</div>\n                  <ng-container *ngIf=\"isContent\">\n                      <div [innerHTML]=\"scrollData.content\"></div>\n                  </ng-container>\n                  <ng-container *ngIf=\"!isContent\">\n                      <img [src]=\"scrollData.img\" alt=\"Los Angeles\" style=\"width:100%;\">\n                      <div class=\"carousel-caption\">\n                          <h3>{{scrollData.caption}}</h3>\n                      </div>\n                  </ng-container>\n              </div>\n              <!-- Left and right controls -->\n              <a class=\"left carousel-control\" [attr.href]=\"'#'+elementId\" data-slide=\"prev\">\n                  <span class=\"glyphicon glyphicon-chevron-left\"></span>\n                  <span class=\"sr-only\">Previous</span>\n              </a>\n              <a class=\"right carousel-control\" [attr.href]=\"'#'+elementId\" data-slide=\"next\">\n                  <span class=\"glyphicon glyphicon-chevron-right\"></span>\n                  <span class=\"sr-only\">Next</span>\n              </a>\n          </div>\n      </div>\n\n  ",
        providers: [scrollview_service_1.ScrollViewService]
    }),
    __metadata("design:paramtypes", [scrollview_service_1.ScrollViewService])
], ScrollViewComponent);
exports.ScrollViewComponent = ScrollViewComponent;
//# sourceMappingURL=scrollview.component.js.map