"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var tabpill_component_1 = require("./tabpill.component");
var TabPaneComponent = (function () {
    function TabPaneComponent() {
        this.onSelect = new core_1.EventEmitter(false);
        this.OPERATION_TOGGLE = '#';
        this.OPERATION_DELETE = '-';
        this.elementId = 'tabpane-' + new Date().getTime();
    }
    TabPaneComponent.prototype.ngOnInit = function () {
    };
    TabPaneComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $('#' + this.elementId).on('click', function (e) {
            _this.selectedTabId = e.target.id; // Need some validation Here!!!
            if (_this.selectedTabId != null && (_this.selectedTabId.charAt(0) == '#' || _this.selectedTabId.charAt(0) == '-')) {
                debugger;
                var op = _this.selectedTabId.charAt(0);
                if (op == _this.OPERATION_TOGGLE) {
                    _this.loadTab(_this.selectedTabId.substr(1));
                }
                if (op == _this.OPERATION_DELETE) {
                    _this.removeTab();
                }
            }
        });
    };
    TabPaneComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        setTimeout(function () {
            var readTabs = _this.tabs.toArray();
            var activeTab = readTabs.find(function (tab) { return tab.active === true; });
            if (!activeTab && readTabs.length > 0)
                readTabs[0].active = true;
        });
    };
    TabPaneComponent.prototype.loadTab = function (tabId) {
        var tabs = this.tabs.toArray();
        tabs.forEach(function (tab) {
            tab.active = false;
            if (tab.elementId == tabId)
                tab.active = true;
        });
    };
    TabPaneComponent.prototype.removeTab = function () {
        var _this = this;
        var tabs = this.tabs.toArray();
        var tabToRemove;
        var previousTabId;
        tabs.forEach(function (tab, index) {
            if (tab.elementId == _this.selectedTabId.substr(1)) {
                tabToRemove = tab;
                tab.active = false;
                if (index != 0) {
                    previousTabId = tabs[index - 1].elementId;
                }
            }
        });
        this.tabs.reset(this.tabs.filter(function (tab) { return tab !== tabToRemove; }));
        var element = document.getElementById('+' + this.selectedTabId.substr(1));
        element.parentNode.removeChild(element);
        this.loadTab(previousTabId);
        $('.nav-tabs').scrollingTabs('refresh');
    };
    TabPaneComponent.prototype.changeActiveTab = function (tab) {
        var tabs = this.tabs.toArray();
        tabs.forEach(function (tab) { return tab.active = false; });
        tab.active = true;
        this.onSelect.emit(tabs.indexOf(tab));
    };
    TabPaneComponent.prototype.getIconClass = function (tab) {
        if (this.icons) {
            return 'glyphicon glyphicon-' + tab.icon;
        }
        else {
            return '';
        }
    };
    return TabPaneComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], TabPaneComponent.prototype, "icons", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], TabPaneComponent.prototype, "pills", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], TabPaneComponent.prototype, "stacked", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], TabPaneComponent.prototype, "closable", void 0);
__decorate([
    core_1.ContentChildren(tabpill_component_1.TabComponent),
    __metadata("design:type", core_1.QueryList)
], TabPaneComponent.prototype, "tabs", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], TabPaneComponent.prototype, "onSelect", void 0);
TabPaneComponent = __decorate([
    core_1.Component({
        selector: 'tab-pane',
        template: "\n      <div [ngClass]=\"{'tabbable tabs-left' : stacked}\">\n\n          <ul [attr.id]=\"elementId\" class=\"nav\" [ngClass]=\"{ 'nav-tabs': !pills, 'nav-pills': pills , 'nav-stacked' : stacked}\" role=\"tablist\">\n              <li role=\"presentation\" *ngFor=\"let tab of tabs\" id=\"+{{tab.elementId}}\" [class.active]=\"tab.active\" data-toggle=\"tab\">\n\n                  <a (click)=\"changeActiveTab(tab)\" id=\"#{{tab.elementId}}\" href=\"#{{tab.elementId}}\" class=\"btn\" role=\"tab\"  [class.disabled]=\"tab.disabled\" [attr.disabled] = \"tab.disabled ? true: null\">\n                      <i *ngIf=\"icons\" [ngClass]=\"getIconClass(tab)\"></i> {{tab.title}}\n                      &nbsp;<span *ngIf=\"closable\" id=\"-{{tab.elementId}}\" class=\"close\">\u00D7</span>\n                      <!-- Need to Fix Font issue! -->\n                  </a>\n\n              </li>\n          </ul>\n\n          <div>\n              <ng-content></ng-content>\n          </div>\n\n\n      </div>\n\n\n  ",
        styles: ["\n  .wrapper {\n      position:relative;\n      margin:0 auto;\n      overflow:hidden;\n      padding:5px;\n      height:50px;\n  }\n\n  .list {\n      position:absolute;\n      left:0px;\n      top:0px;\n      min-width:3000px;\n      margin-left:12px;\n      margin-top:0px;\n  }\n\n  .list li{\n      display:table-cell;\n      position:relative;\n      text-align:center;\n      cursor:grab;\n      cursor:-webkit-grab;\n      color:#efefef;\n      vertical-align:middle;\n  }\n\n  .scroller {\n      text-align:center;\n      cursor:pointer;\n      display:none;\n      padding:7px;\n      padding-top:11px;\n      white-space:no-wrap;\n      vertical-align:middle;\n      background-color:#fff;\n  }\n\n  .scroller-right{\n      float:right;\n  }\n\n  .scroller-left {\n      float:left;\n  }\n\n  /**Stack view css **/\n  .tabs-left > .nav-tabs > li,\n  .tabs-right > .nav-tabs > li {\n      float: none;\n  }\n\n  .tabs-left > .nav-tabs > li > a,\n  .tabs-right > .nav-tabs > li > a {\n      min-width: 74px;\n      margin-right: 0;\n      margin-bottom: 3px;\n  }\n\n  .tabs-left > .nav-tabs {\n      float: left;\n      margin-right: 19px;\n      border-right: 1px solid #ddd;\n  }\n\n  .tabs-left > .nav-tabs > li > a {\n      margin-right: -1px;\n      -webkit-border-radius: 4px 0 0 4px;\n      -moz-border-radius: 4px 0 0 4px;\n      border-radius: 4px 0 0 4px;\n  }\n\n  .tabs-left > .nav-tabs > li > a:hover,\n  .tabs-left > .nav-tabs > li > a:focus {\n      border-color: #eeeeee #dddddd #eeeeee #eeeeee;\n  }\n\n  .tabs-left > .nav-tabs .active > a,\n  .tabs-left > .nav-tabs .active > a:hover,\n  .tabs-left > .nav-tabs .active > a:focus {\n      border-color: #ddd transparent #ddd #ddd;\n      *border-right-color: #ffffff;\n  }\n\n  .tabs-right > .nav-tabs {\n      float: right;\n      margin-left: 19px;\n      border-left: 1px solid #ddd;\n  }\n\n  .tabs-right > .nav-tabs > li > a {\n      margin-left: -1px;\n      -webkit-border-radius: 0 4px 4px 0;\n      -moz-border-radius: 0 4px 4px 0;\n      border-radius: 0 4px 4px 0;\n  }\n\n  .tabs-right > .nav-tabs > li > a:hover,\n  .tabs-right > .nav-tabs > li > a:focus {\n      border-color: #eeeeee #eeeeee #eeeeee #dddddd;\n  }\n\n  .tabs-right > .nav-tabs .active > a,\n  .tabs-right > .nav-tabs .active > a:hover,\n  .tabs-right > .nav-tabs .active > a:focus {\n      border-color: #ddd #ddd #ddd transparent;\n      *border-left-color: #ffffff;\n  }\n  "]
    }),
    __metadata("design:paramtypes", [])
], TabPaneComponent);
exports.TabPaneComponent = TabPaneComponent;
//# sourceMappingURL=tabpane.component.js.map