"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var treedatatable_service_1 = require("./treedatatable.service");
var TreeDataTableComponent = (function () {
    function TreeDataTableComponent(treeDataTableService) {
        this.treeDataTableService = treeDataTableService;
        this.selectedRecord = new core_1.EventEmitter();
        this.columns = [];
        this.columns.push({ text: 'Task', dataIndex: 'task', hidden: false, dataType: 'string' });
        this.columns.push({ text: 'Duration', dataIndex: 'duration', hidden: false, dataType: 'number' });
        this.columns.push({ text: 'User', dataIndex: 'user', hidden: false, dataType: 'string' });
    }
    TreeDataTableComponent.prototype.ngOnInit = function () {
    };
    TreeDataTableComponent.prototype.ngAfterViewInit = function () {
        if (this.httpMethod && this.httpUrl) {
            this.treeDataTableService.fetchData(this, this.httpUrl, this.httpMethod);
        }
    };
    TreeDataTableComponent.prototype.ngOnChanges = function (change) {
        if (this.dataTableBindData) {
            this.setData(this.dataTableBindData);
        }
    };
    TreeDataTableComponent.prototype.setData = function (httpResponse) {
        var treedata = this.getResponseData(httpResponse);
        if (treedata) {
            this.data = treedata;
        }
        this.viewRows = this.createViewRows(this.data, null);
        this.renderData();
    };
    TreeDataTableComponent.prototype.toggle = function (rowData, rowIndex) {
        this.toggleViewRows(rowData, !rowData.expanded, this.viewRows);
    };
    TreeDataTableComponent.prototype.toggleViewRows = function (rowData, expanded1, viewData) {
        if (!rowData.leaf)
            rowData.expanded = expanded1;
        var expanded = rowData.expanded;
        var rowId = rowData.rowId;
        if (!rowData.level) {
            rowData.level = 0;
        }
        for (var cr = 0; cr < viewData.length; cr++) {
            var childRows = viewData[cr];
            if (childRows.parentId == rowId) {
                childRows.visible = expanded;
                childRows.level = rowData.level + 1;
                childRows.tdclass = 'tree-grid-level-' + childRows.level;
                if (childRows.haschildren && !rowData.expanded) {
                    this.toggleViewRows(childRows, rowData.expanded, viewData);
                }
            }
        }
    };
    TreeDataTableComponent.prototype.renderData = function () {
        for (var vr = 0; vr < this.viewRows.length; vr++) {
            var childRows = this.viewRows[vr];
            if (childRows.parentId)
                childRows.visible = false;
            if (!childRows.parentId)
                childRows.visible = true;
        }
    };
    TreeDataTableComponent.prototype.createViewRows = function (data, parentId) {
        var viewTreeTableData = [];
        for (var d = 0; d < data.length; d++) {
            var td = JSON.parse(JSON.stringify(data[d]));
            var rowId = Math.random();
            if (td.children && td.children.length > 0) {
                td['leaf'] = false;
                td['haschildren'] = true;
                td['visible'] = true;
            }
            else {
                td['leaf'] = true;
                td['haschildren'] = false;
                td['visible'] = false;
            }
            td['expanded'] = false;
            td['rowId'] = rowId;
            td['level'] = 1;
            td['tdclass'] = 'tree-grid-level-1';
            if (parentId)
                td['parentId'] = parentId;
            viewTreeTableData.push(td);
            if (td.children && td.children.length > 0) {
                var dataArray = this.createViewRows(td.children, rowId);
                for (var d1 = 0; d1 < dataArray.length; d1++) {
                    var td1 = dataArray[d1];
                    viewTreeTableData.push(td1);
                }
                delete td.children;
            }
        }
        return viewTreeTableData;
    };
    TreeDataTableComponent.prototype.getResponseData = function (httpResponse) {
        var responsedata = httpResponse;
        var dr = this.dataReader.split(".");
        for (var ir = 0; ir < dr.length; ir++) {
            responsedata = responsedata[dr[ir]];
        }
        return responsedata;
    };
    TreeDataTableComponent.prototype.setSelectedRow = function (rowData, event) {
        this.selectedRecord.emit(rowData);
    };
    TreeDataTableComponent.prototype.setSortColumn = function (col) {
        console.log(col);
        this.sortColumn = col;
        this.sortData();
    };
    TreeDataTableComponent.prototype.sortData = function () {
        if (this.sortColumn) {
            if (this.sortColumn.dataIndex && this.sortColumn.dataType) {
                var dataIndex = this.sortColumn.dataIndex;
                var sortColDataIndex_1 = dataIndex;
                if (this.sortColumn.dataType == 'string') {
                    this.data.sort(function (a, b) {
                        debugger;
                        var x = a[sortColDataIndex_1].toLowerCase();
                        var y = b[sortColDataIndex_1].toLowerCase();
                        if (x < y) {
                            return -1;
                        }
                        if (x > y) {
                            return 1;
                        }
                        return 0;
                    });
                    this.viewRows = this.createViewRows(this.data, null);
                    this.renderData();
                }
                else if (this.sortColumn.dataType == 'number') {
                    this.data.sort(function (a, b) {
                        var x = a[sortColDataIndex_1];
                        var y = b[sortColDataIndex_1];
                        return x - y;
                    });
                    this.viewRows = this.createViewRows(this.data, null);
                    this.renderData();
                }
            }
        }
    };
    TreeDataTableComponent.prototype.setColumnVisiblity = function (dataIndex) {
        for (var ic = 0; ic < this.columns.length; ic++) {
            var col = this.columns[ic];
            if (col.dataIndex == dataIndex) {
                col.hidden = !col.hidden;
            }
        }
    };
    return TreeDataTableComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TreeDataTableComponent.prototype, "title", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TreeDataTableComponent.prototype, "httpUrl", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TreeDataTableComponent.prototype, "httpMethod", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TreeDataTableComponent.prototype, "dataReader", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Array)
], TreeDataTableComponent.prototype, "dataTableBindData", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], TreeDataTableComponent.prototype, "pageSize", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], TreeDataTableComponent.prototype, "selectedRecord", void 0);
TreeDataTableComponent = __decorate([
    core_1.Component({
        selector: 'tree-data-table',
        template: "\n        <table  class=\"table table-hover table-bordered \">\n            <thead>\n\n            <tr>\n                <td [attr.colspan]=\"columns.length\" width=\"100%\" align=\"right\">\n\n          <span style=\"float: left\">\n            <b>{{title}}</b>\n          </span>\n\n                    <span style=\"float: right\">\n            <div class=\"dropdown\">\n              <a href=\"#\" class=\"dropdown-toggle\" data-toggle=\"dropdown\" role=\"button\" aria-haspopup=\"true\" aria-expanded=\"false\"><span class=\"glyphicon glyphicon-th-list\"></span></a>\n                  <ul class=\"dropdown-menu dropdown-menu-right\">\n                      <li>\n                          &nbsp;&nbsp;<b> Show Columns</b>\n                      </li>\n                      <li *ngFor=\"let cols of columns\">\n                          <div class=\"checkbox\">\n                              <label>\n                                  &nbsp;&nbsp;<input type=\"checkbox\" (click)=\"setColumnVisiblity(cols.dataIndex)\" [attr.checked]=\"!cols.hidden ? true: null\"> {{cols.text +\" \"}}\n                              </label>\n                          </div>\n                      </li>\n                  </ul>\n            </div>\n          </span>\n                </td>\n            </tr>\n\n\n            <tr>\n                <td  *ngFor=\"let cols of columns\" [hidden]=\"cols.hidden\" >\n                    <b><a (click)=\"setSortColumn(cols)\">{{cols.text}}</a></b>\n                </td>\n            </tr>\n\n            </thead>\n\n            <tr *ngFor=\"let row of viewRows let rowIndex = index\" [hidden]=\"!row.visible\" (click)=\"setSelectedRow(row, $event)\">\n                <td *ngFor=\"let cols of columns let colIndex = index\" [hidden] =\"cols.hidden\" >\n                    <div style=\"cursor: pointer\" *ngIf=\"colIndex == 0\" class=\"tree-grid-levels\"\n                         [ngStyle]=\"{left: row.level*15+'px'}\" (click)=\"toggle(row,rowIndex)\">\n                  <span *ngIf=\"colIndex == 0\" [ngClass]=\"{'glyphicon glyphicon-minus': row.expanded, 'glyphicon glyphicon-plus': (!row.expanded && row.haschildren)}\">\n                  </span>\n                        {{row[cols.dataIndex]}}\n                    </div>\n\n                    <span *ngIf=\"colIndex > 0\" >{{row[cols.dataIndex]}}</span>\n\n                </td>\n            </tr>\n\n\n\n        </table>\n    ",
        providers: [treedatatable_service_1.TreeDataTableService],
        styles: ["\n      .tree-grid-levels{\n        position: relative;\n      }\n     "]
    }),
    __metadata("design:paramtypes", [treedatatable_service_1.TreeDataTableService])
], TreeDataTableComponent);
exports.TreeDataTableComponent = TreeDataTableComponent;
//# sourceMappingURL=treedatatable.component.js.map