import {NgModule, ModuleWithProviders} from '@angular/core';
import {CommonModule} from '@angular/common';
import {WidgetService} from "./src/bootstrap/widget.shared.service";
import {RouterModule} from "@angular/router";
import {ButtonComponent} from "./src/bootstrap/button/button.component";
import {FileuploadComponent} from "./src/bootstrap/fileupload/fileupload.component";
import {DataTableComponent} from "./src/bootstrap/datatable/datatable.component";
import {ColumnComponent} from "./src/bootstrap/datatable/column.component";
import {TreeDataTableComponent} from "./src/bootstrap/treedatatable/treedatatable.component";
import {TreeViewComponent} from "./src/bootstrap/treeview/treeview.component";
import {TabComponent} from "./src/bootstrap/tabpane/tabpill.component";
import {TabPaneComponent} from "./src/bootstrap/tabpane/tabpane.component";
import {CheckGroupComponent} from "./src/bootstrap/checkgroup/checkgroup.component";
import {DateTimeComponent} from "./src/bootstrap/datetimepicker/datetimepicker.component";
import {FormsModule} from "@angular/forms";
import {TextInputComponent} from "./src/bootstrap/textinput/textinput.component";
import {EmailInputComponent} from "./src/bootstrap/emailinput/emailinput.component";
import {HiddenInputComponent} from "./src/bootstrap/hiddeninput/hiddeninput.component";
import {NumberInputComponent} from "./src/bootstrap/numberinput/numberinput.component";
import {PasswordInputComponent} from "./src/bootstrap/passwordinput/passwordinput.component";
import {TextAreaComponent} from "./src/bootstrap/textareainput/textareainput.component";
import {RatingInputComponent} from "./src/bootstrap/ratinginput/ratinginput.component";
import {RadioGroupComponent} from "./src/bootstrap/radiogroup/radiogroup.component";
import {DropDownComponent} from "./src/bootstrap/dropdown/dropdown.component";
import {ScrollViewComponent} from "./src/bootstrap/scrollview/scrollview.component";
import {ItemComponent} from "./src/bootstrap/buttondropdown/dropdown.item.component";
import {ButtonDropdownComponent} from "./src/bootstrap/buttondropdown/button.dropdown.component";
import {ButtonGroupComponent} from "./src/bootstrap/buttongroup/buttongroup.component";
import {ButtonGroupActionComponent} from "./src/bootstrap/buttongroup/buttongroup.action.component";
import {ItemSelectorComponent} from "./src/bootstrap/itemselector/itemselector";
import {ProgressComponent} from "./src/bootstrap/progress/progress.component";

export * from './src/bootstrap/widget.shared.service';
declare var $ : any;
@NgModule({
  imports: [
    CommonModule,
    RouterModule,
    FormsModule
  ],
  declarations: [
    TextInputComponent,
    EmailInputComponent,
    HiddenInputComponent,
    NumberInputComponent,
    PasswordInputComponent,
    TextAreaComponent,
    RatingInputComponent,
    RadioGroupComponent,
    FileuploadComponent,
    ButtonComponent,
    DataTableComponent,
    ColumnComponent,
    DropDownComponent,
    TreeDataTableComponent,
    TreeViewComponent,
    TabComponent,
    TabPaneComponent,
    CheckGroupComponent,
    DateTimeComponent,
    ScrollViewComponent,
    ItemComponent,
    ButtonDropdownComponent,
    ButtonGroupComponent,
    ButtonGroupActionComponent,
    ItemSelectorComponent,
    ProgressComponent
  ],
  exports: [
    ButtonGroupComponent,
    ButtonGroupActionComponent,
    TextInputComponent,
    EmailInputComponent,
    HiddenInputComponent,
    NumberInputComponent,
    PasswordInputComponent,
    TextAreaComponent,
    RatingInputComponent,
    RadioGroupComponent,
    FileuploadComponent,
    ButtonComponent,
    DataTableComponent,
    ColumnComponent,
    DropDownComponent,
    TreeDataTableComponent,
    TreeViewComponent,
    TabComponent,
    TabPaneComponent,
    CheckGroupComponent,
    DateTimeComponent,
    ScrollViewComponent,
    ItemComponent,
    ButtonDropdownComponent,
    ItemSelectorComponent,
    ProgressComponent
  ]
})
export class MetaMagicWidgetModule {
  static forRoot(): ModuleWithProviders {
    return {
      ngModule: MetaMagicWidgetModule,
      providers: [WidgetService]
    };
  }
}
