/**
 * Created by dattaram on 4/5/17.
 */

import {Component, forwardRef, Input, OnInit} from '@angular/core';
import {FormInputBase} from "../baseclass/form.input.base";
import {FileUploadService} from "./fileupload.service";

export const BASE_IMPL_FILEUPLOAD_INPUT : any = {
  provide : FormInputBase,
  useExisting: forwardRef(() => FileuploadComponent)
};

@Component({
  selector: 'file-upload',
  template: `
      <div class="col-lg-9">
          <input type="text" readonly
                 autocomplete="off"
                 class="form-control"
                 data-placement="bottom"  data-trigger="focus" data-html="true" [attr.value]="fileName+'  '+fileSize">
      </div>
      <div class="col-lg-3">
          <label class="btn btn-primary btn-file">
              {{fieldLabel}} <input type="file" [attr.accept]="fileType"  (change)="uploadFile($event)" [attr.multiple]="multipleFile" style="display: none;" #fileupload>
          </label>
      </div>
  `,
  providers : [BASE_IMPL_FILEUPLOAD_INPUT,FileUploadService]
})
export class FileuploadComponent extends FormInputBase implements OnInit {

  @Input()    fieldLabel : string;

  @Input()    url : string;

  @Input()   httpMethod : string;

  @Input()   fileType : string;

  @Input()   multipleFile : string;

  fileSize    : string = '';

  fileName : string = '';

  constructor(private fileUploadService : FileUploadService) {
    super();
  }

  ngOnInit() {
  }

  uploadFile(event : any) {
    let fileList: FileList = event.target.files;
    if (fileList.length > 0) {
      this.fileName = fileList[0].name;
      this.fileSize = (fileList[0].size/1024).toFixed(1);
      this.fileSize = this.fileSize+' Kb';
     // this.fileUploadService.uploadFile(this,this.url,this.httpMethod,fileList);
    }
  }
  setData(requestData : any){

  }
}
