import {Component, Input, OnInit} from '@angular/core';
@Component({
  selector: 'progress-bar',
  template : `      
      
    <div class="progress" *ngIf="showProgress">
      <div class="progress-bar progress-bar-striped active" role="progressbar" [attr.aria-valuenow]="currentValue" [attr.aria-valuemin]="minValue" [attr.aria-valuemax]="maxValue" style="width: 100%">
        <span>{{displayText}}<span class="dotdotdot"></span></span>
      </div>
    </div>
  
  `,
  styles : [`.progress {
    margin: 15px;
  }

  .progress .progress-bar.active {
    font-weight: 700;
    animation: progress-bar-stripes .5s linear infinite;
  }

  .dotdotdot:after {
    font-weight: 300;
    content: '...';
    display: inline-block;
    width: 20px;
    text-align: left;
    animation: dotdotdot 1.5s linear infinite;
  }

  @keyframes dotdotdot {
    0%   { content: '...'; }
    25% { content: ''; }
    50% { content: '.'; }
    75% { content: '..'; }
  }`]
})

export class ProgressComponent implements OnInit{

  @Input()    showProgress : boolean = true;

  @Input()    infinteMode : boolean = true;

  @Input()    minValue : string;

  @Input()    maxValue  : string;

  @Input()    currentValue : string;

  displayText : string;



  constructor(){

  }

  ngOnInit(){
    if(this.infinteMode){
      this.displayText = 'Please wait';
      this.currentValue = '100';
      this.minValue = '0';
      this.maxValue = '100';
    }

    else
      this.displayText = this.currentValue+'%';
  }
}


